#!/usr/local/bin/perl
use strict;
use warnings;

my %salutation = ( Mr => 'Mister',
		   Dr => 'Doctor',
		   Ms => 'Mizz', );
my %suffix     = ( 'Jr.' => 'Junior',
		   'II'  => 'The Second',
		   'III' => 'The Third',
		   'IV'  => 'The Fourth', );

while (<DATA>)
{
  s/(?<=(?<sal>Mr|Dr|Ms)\. )/($salutation{$+{sal}}) /;    # %+ is Perl 5.10.0
  print;
  s/(?= (?<suf>Jr\.|[IVX]+))/ ($suffix{$+{suf}})/;
  print;
}

__END__
Dr. William Jones
Mr. Nathaniel Simpson III
Frederick Johnston Jr.
Richard Rogers
