#!/usr/local/bin/perl
use strict;
use warnings;

my %dispatch = ( define  => \&define,
		 push    => \&push,
		 pop     => \&pop,
		 shift   => \&shift,
		 unshift => \&unshift,
		 splice  => \&splice,
		 print   => \&print,
                 quit    => sub { print "Quitting\n"; exit }
	       );
my @array = ( undef );

while ( <STDIN> )
{
  chomp;
  my ($command, @args) = split;
  $dispatch{$command} or die "No such command $command\n";
  $dispatch{$command}->( @args );
}

sub define  { @array = @_                                          }
sub push    { check(); push @array, @_                             }
sub pop     { check(); pop @array                                  }
sub shift   { check(); shift @array                                }
sub unshift { check(); unshift @array, @_                          }
sub splice  { check(); splice @array, $_[0], $_[1], @_[2..$#_]     }
sub print   { check(); print "<< @array >>\n"                      }

sub check   { die "Array not defined yet" unless defined $array[0] }
