#!/usr/local/bin/perl
use strict;
use warnings;

analyze( { movie => 'Gandhi', award => 'Editing' } );
analyze( [ qw(Editing Acting Directing) ] );
analyze( 42 );
analyze( \42 );

sub analyze
{
  my $ref = shift;

  return warn "This isn't a reference\n" unless ref $ref;
  print "Reference to ", lc ref( $ref), ": ";
  if ( ref $ref eq 'HASH' )
  {
    print hash_to_string( %$ref ), "\n";
  }
  elsif ( ref $ref eq 'ARRAY' )
  {
    print "<< @$ref >>\n";
  }
  elsif ( ref $ref eq 'SCALAR' )
  {
    print "$$ref\n";
  }
  else
  {
    print "I don't know how to print that\n";
  }
}


sub hash_to_string
{
  my %hash = @_;

  my $str = join ', ' => map { "$_=>$hash{$_}" }
                             sort keys %hash;
  return "<< $str >>";
}
