package Oscar::Ceremony;

use Moose;   # Does use strict/warnings for us
use MooseX::StrictConstructor;
use namespace::autoclean;

has year   => ( is => 'rw', isa => 'Int' );
has awards => ( is => 'rw', isa => 'ArrayRef[Oscar]', auto_deref => 1 );

sub movies
{
  my $self = shift;

  my %movie_seen;
  for my $award ( $self->awards )
  {
    $movie_seen{ $award->for->title }++;
  }
  return sort keys %movie_seen;
}

__PACKAGE__->meta->make_immutable;

1;
