package ReadOscars;
use strict;
use warnings;

use base 'Exporter';
our @EXPORT_OK = qw(read_oscars);

sub read_oscars
{
  my $input = shift;

  my (%oscars, %movie);

  open my $fh, '<', $input or die "Cannot open $input: $!\n";
  my %award_count;
  my $year;
  while ( <$fh> )
  {
    chomp;
    /\A(\d+)\z/ and $year = $1;
    my ($for, $rest) = /([^:]+): (?:Written for )?(.*)/ or next;
    my @people;
    my $what;
    if ( $for =~ /\AAct/ )
    {
      (my $who, $what) = ( $rest =~ /(.*) as .*? in (.*)/ ) or next;
      @people = $who;
    }
    else
    {
      (my $list, $what) = ( $rest =~ /(.*?\S)\s+for (.*)/ ) or next;
      $list =~ s/, (Co-)?Producers?//g;
      @people = split /, | and | & |;\s+/, $list;
      s/.* by // for @people;
    }
    $movie{$what}{$for} = $oscars{$year}{$for} = \@people;
  }

  return (\%oscars, \%movie);
}

1;
